<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch, ref, unref, onMounted } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'
import { useI18n } from '@/hooks/web/useI18n'
import { ElTree, ElCheckboxGroup, ElCheckbox } from 'element-plus'
import { getAdminInfo } from '@/api/system/admin'
import { getRoleApi } from '@/api/system/role'
import { filter, eachTree } from '@/utils/tree'
import { roluData } from '@/utils/analysis'
import { findIndex } from '@/utils'
import { MenuData } from '@/api/system/menu/types'

const { t } = useI18n()

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  }
})

const treeRef = ref<typeof ElTree>()
const storeTreeRef = ref<typeof ElTree>()
const erpTreeRef = ref<typeof ElTree>()
const casTreeRef = ref<typeof ElTree>()

onMounted(async () => {
  getMenuList()
})

const formSchema = ref<FormSchema[]>([
  {
    field: 'role_name',
    label: t('role.roleName'),
    component: 'Input'
  },
  {
    field: 'status',
    label: t('menu.status'),
    component: 'Select',
    componentProps: {
      options: [
        {
          label: t('userDemo.disable'),
          value: 0
        },
        {
          label: t('userDemo.enable'),
          value: 1
        }
      ]
    }
  },
  {
    field: 'checked_menus',
    label: '门店菜单',
    colProps: {
      span: 24
    },
    formItemProps: {
      slots: {
        default: () => {
          return (
            <>
              <div class="flex w-full">
                <div class="flex-1">
                  <ElTree
                    ref={storeTreeRef}
                    show-checkbox
                    node-key="id"
                    highlight-current
                    expand-on-click-node={false}
                    data={storeTreeData.value}
                    onNode-click={nodeStoreClick}
                  >
                    {{
                      default: (data) => {
                        return <span>{data.data.meta.title}</span>
                      }
                    }}
                  </ElTree>
                </div>
                <div class="flex-1">
                  {unref(currentStoreTreeData) && unref(currentStoreTreeData)?.permissionList ? (
                    <ElCheckboxGroup v-model={unref(currentStoreTreeData).meta.permission}>
                      {unref(currentStoreTreeData)?.permissionList.map((v: any) => {
                        return <ElCheckbox label={v.value}>{v.label}</ElCheckbox>
                      })}
                    </ElCheckboxGroup>
                  ) : null}
                </div>
              </div>
            </>
          )
        }
      }
    }
  },
  {
    field: 'erp_rules',
    label: 'ERP菜单',
    colProps: {
      span: 24
    },
    formItemProps: {
      slots: {
        default: () => {
          return (
            <>
              <div class="flex w-full">
                <div class="flex-1">
                  <ElTree
                    ref={erpTreeRef}
                    show-checkbox
                    node-key="id"
                    highlight-current
                    expand-on-click-node={false}
                    data={erpTreeData.value}
                    onNode-click={nodeErpClick}
                  >
                    {{
                      default: (data) => {
                        return <span>{data.data.meta.title}</span>
                      }
                    }}
                  </ElTree>
                </div>
                <div class="flex-1">
                  {unref(currentStoreTreeData) && unref(currentStoreTreeData)?.permissionList ? (
                    <ElCheckboxGroup v-model={unref(currentStoreTreeData).meta.permission}>
                      {unref(currentStoreTreeData)?.permissionList.map((v: any) => {
                        return <ElCheckbox label={v.value}>{v.label}</ElCheckbox>
                      })}
                    </ElCheckboxGroup>
                  ) : null}
                </div>
              </div>
            </>
          )
        }
      }
    }
  },
  {
    field: 'cashier_rules',
    label: '收银台菜单',
    colProps: {
      span: 24
    },
    formItemProps: {
      slots: {
        default: () => {
          return (
            <>
              <div class="flex w-full">
                <div class="flex-1">
                  <ElTree
                    ref={casTreeRef}
                    show-checkbox
                    node-key="id"
                    highlight-current
                    expand-on-click-node={false}
                    data={casTreeData.value}
                    onNode-click={nodeCasClick}
                  >
                    {{
                      default: (data) => {
                        return <span>{data.data.meta.title}</span>
                      }
                    }}
                  </ElTree>
                </div>
                <div class="flex-1">
                  {unref(currentCasTreeData) && unref(currentCasTreeData)?.permissionList ? (
                    <ElCheckboxGroup v-model={unref(currentCasTreeData).meta.permission}>
                      {unref(currentCasTreeData)?.permissionList.map((v: any) => {
                        return <ElCheckbox label={v.value}>{v.label}</ElCheckbox>
                      })}
                    </ElCheckboxGroup>
                  ) : null}
                </div>
              </div>
            </>
          )
        }
      }
    }
  }
])

const currentTreeData = ref()
const currentStoreTreeData = ref()
const currentErpTreeData = ref()
const currentCasTreeData = ref()

// const nodeClick = (treeData: any) => {
//   currentTreeData.value = treeData
// }
const nodeStoreClick = (storeTreeData: any) => {
  currentStoreTreeData.value = storeTreeData
}
const nodeErpClick = (storeTreeData: any) => {
  currentErpTreeData.value = storeTreeData
}
const nodeCasClick = (casTreeData: any) => {
  currentCasTreeData.value = casTreeData
}
const rules = reactive({
  role_name: [required()],
  role: [required()],
  status: [required()]
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const treeData = ref<MenuData[]>([])
const storeTreeData = ref<MenuData[]>([])
const erpTreeData = ref<MenuData[]>([])
const casTreeData = ref<MenuData[]>([])

const getMenuList = async () => {
  const res = await getAdminInfo()
  const storeRes = await getAdminInfo({ type: 2 })
  const erpRes = await getAdminInfo({ type: 3 })
  const casRes = await getAdminInfo({ type: 4 })
  const list = roluData(res.data.role)
  const storeRole = roluData(storeRes.data.role)
  const erpRole = roluData(erpRes.data.role)
  const casRole = roluData(casRes.data.role)

  if (list) {
    treeData.value = list

    if (props.currentRow?.id) {
      const checked: any[] = []
      const rolelist = await getRoleApi({ id: props.currentRow?.id })

      eachTree(rolelist.data.rules.split(','), (v) => {
        checked.push({
          id: v,
          permission: v.meta?.permission || []
        })
      })
      eachTree(treeData.value, (v) => {
        const index = findIndex(checked, (item) => {
          return item.id === v.id
        })
        if (index > -1) {
          const meta = { ...(v.meta || {}) }
          meta.permission = checked[index].permission
          v.meta = meta
        }
      })
      for (const item of checked) {
        unref(treeRef)?.setChecked(item.id, true, false)
      }
    }
  }
  if (storeRole) {
    storeTreeData.value = storeRole

    if (props.currentRow?.id) {
      const checked: any[] = []
      const storeRolelist = await getRoleApi({ id: props.currentRow?.id })

      eachTree(storeRolelist.data.rules.split(','), (v) => {
        checked.push({
          id: v,
          permission: v.meta?.permission || []
        })
      })
      eachTree(storeTreeData.value, (v) => {
        const index = findIndex(checked, (item) => {
          return item.id === v.id
        })
        if (index > -1) {
          const meta = { ...(v.meta || {}) }
          meta.permission = checked[index].permission
          v.meta = meta
        }
      })
      for (const item of checked) {
        unref(storeTreeRef)?.setChecked(item.id, true, false)
      }
    }
  }
  if (erpRole) {
    erpTreeData.value = erpRole

    if (props.currentRow?.id) {
      const checked: any[] = []
      const erpRolelist = await getRoleApi({ id: props.currentRow?.id })

      eachTree(erpRolelist.data.erp_rules.split(','), (v) => {
        checked.push({
          id: v,
          permission: v.meta?.permission || []
        })
      })
      eachTree(erpTreeData.value, (v) => {
        const index = findIndex(checked, (item) => {
          return item.id === v.id
        })
        if (index > -1) {
          const meta = { ...(v.meta || {}) }
          meta.permission = checked[index].permission
          v.meta = meta
        }
      })
      for (const item of checked) {
        unref(erpTreeRef)?.setChecked(item.id, true, false)
      }
    }
  }
  if (casRole) {
    casTreeData.value = casRole

    if (props.currentRow?.id) {
      const checked: any[] = []
      const casRolelist = await getRoleApi({ id: props.currentRow?.id })

      eachTree(casRolelist.data.cashier_rules.split(','), (v) => {
        checked.push({
          id: v,
          permission: v.meta?.permission || []
        })
      })
      eachTree(casTreeData.value, (v) => {
        const index = findIndex(checked, (item) => {
          return item.id === v.id
        })
        if (index > -1) {
          const meta = { ...(v.meta || {}) }
          meta.permission = checked[index].permission
          v.meta = meta
        }
      })
      for (const item of checked) {
        unref(casTreeRef)?.setChecked(item.id, true, false)
      }
    }
  }
}
const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    const checkedKeys = unref(treeRef)?.getCheckedKeys() || []
    const checkedStoreKeys = unref(storeTreeRef)?.getCheckedKeys() || []
    const checkedErpKeys = unref(erpTreeRef)?.getCheckedKeys() || []
    const checkedCasKeys = unref(casTreeRef)?.getCheckedKeys() || []
    const data = filter(unref(treeData), (item: any) => {
      return checkedKeys.includes(item.id)
    })
    const storeData = filter(unref(storeTreeData), (item: any) => {
      return checkedStoreKeys.includes(item.id)
    })
    const erpData = filter(unref(erpTreeData), (item: any) => {
      return checkedErpKeys.includes(item.id)
    })
    const casData = filter(unref(casTreeData), (item: any) => {
      return checkedCasKeys.includes(item.id)
    })

    
    formData.menu = data || []
    formData.storeMenu = storeData || []
    formData.erpMenu = erpData || []
    formData.casMenu = casData || []
    // console.log()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>
